-- Devolver los nombres de los fabricantes que venden el producto con nro 10
-- sin join
SELECT f.nombre
FROM fabricantes f JOIN ventas v USING(numf)
WHERE v.nump=10 

select *
from ventas v right join productos p on p.nump=v.nump



-- con join


-- Devolver los nombres de los fabricantes que venden el producto 10 
-- y también el producto 3
-- sin exists
SELECT *
FROM (fabricantes f NATURAL JOIN ventas v1) 
				    JOIN ventas v2 ON v1.numf = v2.numf 
WHERE v1.nump=10 AND v2.nump=8

-- con exists
SELECT *
FROM  fabricantes f NATURAL JOIN ventas v
WHERE v.nump=10 AND --haya vendido el producto 10
      EXISTS (SELECT 1
	  		  FROM ventas v2
	  		  WHERE v2.nump=8 AND f.numf=v2.numf)
			  
			  
-- Devolver los nombres de los fabricantes que 
-- no venden el producto 10 (que venden SOLO el producto 3)
SELECT DISTINCT v.preciounit, f.nombre
FROM fabricantes f NATURAL JOIN ventas v
WHERE f.numf NOT IN (SELECT numf
				  	FROM ventas
				  	WHERE nump =10 )
ORDER BY f.nombre DESC

EXCEPT
SELECT numf
FROM fabricantes f 
WHERE NOT EXISTS (SELECT 1
				   FROM ventas v
				   WHERE v.numf = f.numf AND v.nump=10)

-- Devolver los nombres de los fabricantes que venden todos los productos con descripción “d1” 


-- Devolver los nombres de los fabricantes que venden los productos más caros
-- sin exists
-- con exists

-------------------------------------------------- 
--Devolver los nombres de los fabricantes que venden el producto 
-- 10 o también el producto 8

select  distinct f.numf, f.nombre
from fabricantes f natural join ventas natural join productos p
where p.nump=10 or p.nump=8


SELECT f.numf, f.nombre
from fabricantes f natural join ventas natural join productos p
where p.nump=10
UNION
SELECT f.numf, f.nombre
from fabricantes f natural join ventas natural join productos p
where p.nump=8
-------------------------------------------------------
-- Devolver los nombres de fabricantes de los que se desconoce su dirección

-------------------------------------------------------
-- Devolver el promedio de precio unitario
SELECT count( distinct numf)
FROM ventas
WHERE nump=10

-------------------------------------------------------
-- Devolver número de fábricante y 
-- la cantidad de productos distintos que vende cada fabricante.
select numf, count(distinct nump), nump
from ventas
group by numf, nump

-- Devolver nombre de fábricante y la 
-- cantidad de productos distintos que vende cada fabricante.
SELECT f.nombre, COUNT(nump)
FROM ventas v NATURAL JOIN fabricantes f
GROUP BY f.nombre
ORDER BY f.nombre



SELECT f.nombre, f.numf, COUNT(nump)
FROM ventas v NATURAL JOIN fabricantes f
GROUP BY f.numf
ORDER BY f.nombre

select f.numf, f.nombre, v.nump
from ventas v natural join fabricantes f
where f.nombre= 'Ana Suárez'
order by v.nump



-- Devolver el promedio de los precios unitarios a los que vende cada fabricante

-- Dar, para los fabricantes que vendieron más de 5 productos distintos,
--el promedio de cantidad vendida de los productos
SELECT avg(preciounit), count(distinct nump)
FROM ventas
GROUP BY numf
HAVING count(distinct nump)>6




